
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include <fcntl.h>
#include <sys/stat.h>

#define BUFLEN 512

void diep(char *s)
{
  perror(s);
  exit(1);
}

int main(int argc, char *argv[])
{
  struct sockaddr_in si_me;
  int s;
  char buf[BUFLEN];
  int antwort;
  FILE *writefile;
  int i;
  int laenge;

  //Sollte reichen, die PNGs sind immer so 60k gross.
  unsigned char screenbuf[100000];

  //Pruefen ob User doof
  if (argc!=2) {
    printf("\nrtb2000 fu.png\n\n");
    diep("Argument error!");
  }
     

  //TCP-Socket zum Oszi aufmachen 
  if ((s=socket(AF_INET, SOCK_STREAM, 0))==-1)  diep("kein socket");
  memset((char *) &si_me, 0, sizeof(si_me));
  si_me.sin_family = AF_INET;
  si_me.sin_port = htons(5025); //Port für SCPI-Kommando über TCP
  inet_aton("192.168.12.220", (struct in_addr *) &si_me.sin_addr.s_addr );
  if ( connect(s,(struct sockaddr *) &si_me , sizeof(si_me))==-1) diep("kein connect");

  //Kommando erzeugen und absenden
  //   sprintf(buf,"*IDN?\n"); 
  //  sprintf(buf,"DVM1:ENAB ON\n");  //Digitalmultimeter  einschalten
  sprintf(buf,"HCOP:DATA?\n");  //Oszi zum Senden auffordern.
  write(s,buf,strlen(buf));
  
  //Das Oszi sendet erst mal die Filelaenge, und irgendwas anderes
  //ist leider im Handbuch nicht dokumentiert.
  if (antwort = read(s,buf,7)<0) diep("keine Antwort");
  *(buf+7)=0;  
  sscanf(buf+2,"%i",&laenge);

  printf("Filelaenge: %i Bytes\n",laenge);

  //File erzeugen
  creat(argv[1],0600);
  writefile=fopen(argv[1],"wb");

  i=0;

  //Das Bild abholen
  while(i<laenge)
    {
      //Segmente mit maximaler Blocklaenge holen
      if ( (laenge - i) >=1460)
	{
	  if (antwort = read(s,screenbuf,1460)<0) diep("keine Antwort");
	  fwrite(screenbuf,1,1460,writefile);
	  i+=1460;
	  //	  printf("Data: %i\n",i); fflush(NULL);
	}
      else
	{
	  //Das letzte Segment holen
	  if (antwort = read(s,screenbuf,(laenge-i))<0) diep("keine Antwort");
	  fwrite(screenbuf,1,(laenge-i),writefile);
	  i+=(laenge-i);
	  //	  printf("Data: %i\n",i); fflush(NULL);
	}
    }

  close(s);
  fclose(writefile);

  printf("File %s gelesen.\n",argv[1]);

  return 0;
}
